searchNodes=[{"ref":"readme.html","title":"Raspberry Pi Model A+, B, and B+","type":"extras","doc":"Raspberry Pi Model A+, B, and B+ This is the base Nerves System configuration for the Raspberry Pi A+, B, and B+. It will also work with the Raspberry Pi Zero, but usually nerves_system_rpi0 is preferable since it configures the USB port so that it can be plugged into a computer. This is very convenient for powering and debugging the Pi Zero. If you want to use the Raspberry Pi Zero&#39;s USB port in &quot;host&quot; mode (e.g., to attach a USB Flash drive or other peripheral), then this repository works and may be more appropriate. This is not the configuration for the Raspberry Pi 2 or 3. [Image credit](#fritzing) FeatureDescription CPU700 MHz ARM1176JZF-S for A+, B, and B+, 1 GHz ARM1176JZF-S for the Zero Memory256 MB for rev 1 boards, 512 MB for rev 2 and the Zero StorageMicroSD Linux kernel4.19 w/ Raspberry Pi patches IEx terminalHDMI and USB keyboard (can be changed to UART) GPIO, I2C, SPIYes - Elixir Circuits ADCNo PWMYes, but no Elixir support UART1 available - ttyAMA0 CameraYes - via rpi-userland EthernetYes (only on the B and B+) WiFiRequires USB WiFi dongle BluetoothNot supported AudioHDMI/Stereo out"},{"ref":"readme.html#using","title":"Raspberry Pi Model A+, B, and B+ - Using","type":"extras","doc":"The most common way of using this Nerves System is create a project with mix nerves.new and to export MIX_TARGET=rpi. See the Getting started guide for more information. If you need custom modifications to this system for your device, clone this repository and update as described in Making custom systems If you&#39;re new to Nerves, check out the nerves_init_gadget project for creating a starter project. It will get you started with the basics like bringing up networking, initializing the writable application data partition, and enabling ssh-based firmware updates. It&#39;s easiest to begin by using the wired Ethernet interface &#39;eth0&#39; and DHCP if you have a model B/B+."},{"ref":"readme.html#supported-usb-wifi-devices","title":"Raspberry Pi Model A+, B, and B+ - Supported USB WiFi devices","type":"extras","doc":"The base image includes drivers and firmware for Ralink RT53xx (rt2800usb driver) and RealTek RTL8712U (r8712u driver) devices. We are still working out which subset of all possible WiFi dongles to support in our images. At some point, we may have the option to support all dongles and selectively install modules at packaging time, but until then, these drivers and their associated firmware blobs add significantly to Nerves release images. If you are unsure what driver your WiFi dongle requires, run Raspbian and configure WiFi for your device. At a shell prompt, run lsmod to see which drivers are loaded. Running dmesg may also give a clue. When using dmesg, reinsert the USB dongle to generate new log messages if you don&#39;t see them."},{"ref":"readme.html#audio","title":"Raspberry Pi Model A+, B, and B+ - Audio","type":"extras","doc":"The Raspberry Pi has many options for audio output. This system supports the HDMI and stereo audio jack output. The Linux ALSA drivers are used for audio output. To try it out, run: :os.cmd(&#39;espeak -ven+f5 -k5 -w /tmp/out.wav Hello&#39;) :os.cmd(&#39;aplay -q /tmp/out.wav&#39;) The general Raspberry Pi audio documentation mostly applies to Nerves. For example, to force audio out the HDMI port, run: :os.cmd(&#39;amixer cset numid=3 2&#39;) Change the last argument to amixer to 1 to output to the stereo output jack."},{"ref":"readme.html#provisioning-devices","title":"Raspberry Pi Model A+, B, and B+ - Provisioning devices","type":"extras","doc":"This system supports storing provisioning information in a small key-value store outside of any filesystem. Provisioning is an optional step and reasonable defaults are provided if this is missing. Provisioning information can be queried using the Nerves.Runtime KV store&#39;s Nerves.Runtime.KV.get/1 function. Keys used by this system are: KeyExample ValueDescription nerves_serial_number&quot;12345678&quot;By default, this string is used to create unique hostnames and Erlang node names. If unset, it defaults to part of the Raspberry Pi&#39;s device ID. The normal procedure would be to set these keys once in manufacturing or before deployment and then leave them alone. For example, to provision a serial number on a running device, run the following and reboot: iex&gt; cmd(&quot;fw_setenv nerves_serial_number 12345678&quot;) This system supports setting the serial number offline. To do this, set the NERVES_SERIAL_NUMBER environment variable when burning the firmware. If you&#39;re programming MicroSD cards using fwup, the commandline is: sudo NERVES_SERIAL_NUMBER=12345678 fwup path_to_firmware.fw Serial numbers are stored on the MicroSD card so if the MicroSD card is replaced, the serial number will need to be reprogrammed. The numbers are stored in a U-boot environment block. This is a special region that is separate from the application partition so reformatting the application partition will not lose the serial number or any other data stored in this block. Additional key value pairs can be provisioned by overriding the default provisioning.conf file location by setting the environment variable NERVES_PROVISIONING=/path/to/provisioning.conf. The default provisioning.conf will set the nerves_serial_number, if you override the location to this file, you will be responsible for setting this yourself."},{"ref":"readme.html#linux-kernel-and-rpi-firmware-userland","title":"Raspberry Pi Model A+, B, and B+ - Linux kernel and RPi firmware/userland","type":"extras","doc":"There&#39;s a subtle coupling between the nerves_system_br version and the Linux kernel version used here. nerves_system_br provides the versions of rpi-userland and rpi-firmware that get installed. I prefer to match them to the Linux kernel to avoid any issues. Unfortunately, none of these are tagged by the Raspberry Pi Foundation so I either attempt to match what&#39;s in Raspbian or take versions of the repositories that have similar commit times. Image credit: This image is from the Fritzing parts library."}]